Attribute VB_Name = "modReportHandling"
Option Explicit

Public ActualReport As String

Public Sub WriteReportTemplateToFile()
    Dim i As Integer
    Dim ReportTemplateContent As String

    'Delete the old report template content
    ReportTemplateContent = vbNullString

    For i = 0 To frmReportConfiguration.lstHeaderReport.ListCount - 2
        ReportTemplateContent = ReportTemplateContent & _
            "H=" & frmReportConfiguration.lstHeaderReport.List(i) & vbCrLf
    Next i

    For i = 0 To frmReportConfiguration.lstVulnerabilityReport.ListCount - 2
        ReportTemplateContent = ReportTemplateContent & _
            "V=" & frmReportConfiguration.lstVulnerabilityReport.List(i) & vbCrLf
    Next i

    'save the actual report template as file
    On Error Resume Next 'Workaround! No directory checking yet!
    Open App.Path & "\reporttemplates\default.reporttemplate" For Output As #1
        Print #1, ReportTemplateContent
    Close

End Sub

Private Sub WriteDefaultReportToFile()
    Dim ReportTemplate As String
        
    ReportTemplate = _
    "H = scan_target" & vbCrLf & _
    "H = scan_time" & vbCrLf & _
    "H = scan_date" & vbCrLf & _
    "H = scan_mode" & vbCrLf & _
    "H=<br>" & vbCrLf & _
    "H = software_version" & vbCrLf & _
    "H = software_pluginscount" & vbCrLf & _
    "H=<br>" & vbCrLf

    ReportTemplate = ReportTemplate & _
    "V = plugin_id" & vbCrLf & _
    "V = plugin_name" & vbCrLf & _
    "V = plugin_protocol" & vbCrLf & _
    "V = plugin_port" & vbCrLf & _
    "V = bug_severity" & vbCrLf & _
    "V = bug_advisory" & vbCrLf & _
    "V = bug_affected" & vbCrLf & _
    "V = bug_not_affected" & vbCrLf & _
    "V = bug_vulnerability_class" & vbCrLf & _
    "V = bug_exploit_url" & vbCrLf
    
    ReportTemplate = ReportTemplate & _
    "V=<br>" & vbCrLf & _
    "V = bug_description" & vbCrLf & _
    "V=<br>" & vbCrLf & _
    "V = bug_response" & vbCrLf & _
    "V=<br>" & vbCrLf & _
    "V = bug_solution" & vbCrLf & _
    "V=<br>" & vbCrLf & _
    "V = source_cve" & vbCrLf & _
    "V = source_securityfocus_bid"
    
    'save default report to a file
    On Error Resume Next 'Workaround! No directory checking yet!
    Open App.Path & "\reporttemplates\default.reporttemplate" For Output As #1
        Print #1, ReportTemplate
    Close
End Sub

Public Sub WriteReportHeader()
    Dim Temp As String

    'Check the existence of the report template
    On Error Resume Next 'Workaround! No directory checking yet!
    If (Dir$(App.Path & "\reporttemplates\default.reporttemplate", 16) <> "") = False Then
        MkDir (App.Path & "\reporttemplates\")
        Call WriteDefaultReportToFile
    End If

    'Open the default report
    Open App.Path & "\reporttemplates\default.reporttemplate" For Input As #1
        Do While Not EOF(1)
            Line Input #1, Temp
            
            If InStr(1, Temp, "H=") Then
                'write the selected item
                If InStr(3, Temp, "scan_target") Then
                    ActualReport = ActualReport & _
                        "Scan target: " & Target & vbCrLf
                ElseIf InStr(3, Temp, "scan_date") Then
                    ActualReport = ActualReport & _
                        "Scan date: " & Date & vbCrLf
                ElseIf InStr(3, Temp, "scan_time") Then
                    ActualReport = ActualReport & _
                        "Scan time: " & Time & vbCrLf
                ElseIf InStr(3, Temp, "scan_mode") Then
                    ActualReport = ActualReport & _
                        "Attack mode: " & AttackMode & vbCrLf
                ElseIf InStr(3, Temp, "software_version") Then
                    ActualReport = ActualReport & _
                        "Software: " & frmMain.Caption & vbCrLf
                ElseIf InStr(3, Temp, "software_pluginscount") Then
                    ActualReport = ActualReport & _
                        "Plugins count: " & frmMain.lsvPlugins.ListItems.Count & vbCrLf
                ElseIf InStr(3, Temp, "<br>") Then
                   ActualReport = ActualReport & vbCrLf
                End If
            End If
        Loop
    Close

End Sub

Public Sub WriteReportVulnerability()
    Dim Temp As String

    'Open and read the report template file
    Open App.Path & "\reporttemplates\default.reporttemplate" For Input As #1
        Do While Not EOF(1)
            Line Input #1, Temp
            
            If InStr(1, Temp, "V=") Then
                'write the selected item
                If InStr(3, Temp, "plugin_id") Then
                    ActualReport = ActualReport & _
                        "Plugin ID: " & plugin_id & vbCrLf
                ElseIf InStr(3, Temp, "plugin_name") Then
                    ActualReport = ActualReport & _
                        "Plugin name: " & plugin_name & vbCrLf
                ElseIf InStr(3, Temp, "plugin_family") Then
                    ActualReport = ActualReport & _
                        "Plugin family: " & plugin_family & vbCrLf
                ElseIf InStr(3, Temp, "plugin_by") Then
                    ActualReport = ActualReport & _
                        "Plugin by: " & plugin_family & vbCrLf
                ElseIf InStr(3, Temp, "plugin_create_date") Then
                    ActualReport = ActualReport & _
                        "Plugin create date: " & plugin_create_date & vbCrLf
                ElseIf InStr(3, Temp, "plugin_version") Then
                    ActualReport = ActualReport & _
                        "Plugin version: " & plugin_version & vbCrLf
                ElseIf InStr(3, Temp, "plugin_protocol") Then
                    ActualReport = ActualReport & _
                        "Protocol: " & plugin_protocol & vbCrLf
                ElseIf InStr(3, Temp, "plugin_port") Then
                    ActualReport = ActualReport & _
                        "Port: " & plugin_port & vbCrLf
                ElseIf InStr(3, Temp, "plugin_request") Then
                    ActualReport = ActualReport & _
                        "Plugin request: " & plugin_request & vbCrLf
        ''''''''''''''''''''''''''''''''''''''''''
                ElseIf InStr(3, Temp, "plugin_trigger") Then
                    ActualReport = ActualReport & _
                        "Plugin trigger: " & plugin_trigger & vbCrLf
                ElseIf InStr(3, Temp, "bug_published_by") Then
                    ActualReport = ActualReport & _
                        "Bug published by: " & bug_published_by & vbCrLf
                ElseIf InStr(3, Temp, "bug_date_published") Then
                    ActualReport = ActualReport & _
                        "Bug published date: " & bug_date_published & vbCrLf
                ElseIf InStr(3, Temp, "bug_advisory") Then
                    ActualReport = ActualReport & _
                        "Advisory: " & bug_advisory & vbCrLf
                ElseIf InStr(3, Temp, "bug_affected") Then
                    ActualReport = ActualReport & _
                        "Affected: " & bug_affected & vbCrLf
                ElseIf InStr(3, Temp, "bug_not_affected") Then
                    ActualReport = ActualReport & _
                        "Not affected: " & bug_not_affected & vbCrLf
                ElseIf InStr(3, Temp, "bug_vulnerability_class") Then
                    ActualReport = ActualReport & _
                        "Vulnerability class: " & bug_vulnerability_class & vbCrLf
                ElseIf InStr(3, Temp, "bug_description") Then
                    ActualReport = ActualReport & _
                        "Description: " & bug_description & vbCrLf
                ElseIf InStr(3, Temp, "bug_response") Then
                    ActualReport = ActualReport & _
                        "Response: " & vbCrLf & vbCrLf & _
                            Mid(LastResponse, 1, 1000)
                ElseIf InStr(3, Temp, "bug_solution") Then
                    ActualReport = ActualReport & _
                        "Solution: " & bug_solution & vbCrLf
                ElseIf InStr(3, Temp, "bug_fixing_time") Then
                    ActualReport = ActualReport & _
                        "Time to fix: " & bug_fixing_time & vbCrLf
                ElseIf InStr(3, Temp, "bug_exploit_availability") Then
                    ActualReport = ActualReport & _
                        "Exploit available: " & bug_exploit_availability & vbCrLf
                ElseIf InStr(3, Temp, "bug_exploit_url") Then
                    ActualReport = ActualReport & _
                        "Exploit URL: " & bug_exploit_url & vbCrLf
                ElseIf InStr(3, Temp, "bug_severity") Then
                    ActualReport = ActualReport & _
                        "Severity: " & bug_severity & vbCrLf
                ElseIf InStr(3, Temp, "bug_popularity") Then
                    ActualReport = ActualReport & _
                        "Popularity: " & bug_popularity & vbCrLf
                ElseIf InStr(3, Temp, "bug_simplicity") Then
                    ActualReport = ActualReport & _
                        "Simplicity: " & bug_simplicity & vbCrLf
                ElseIf InStr(3, Temp, "bug_impact") Then
                    ActualReport = ActualReport & _
                        "Impact: " & bug_impact & vbCrLf
                ElseIf InStr(3, Temp, "bug_risk") Then
                    ActualReport = ActualReport & _
                        "Risk: " & bug_risk & vbCrLf
                ElseIf InStr(3, Temp, "bug_nessus_risk") Then
                    ActualReport = ActualReport & _
                        "Nessus risk: " & bug_nessus_risk & vbCrLf
                ElseIf InStr(3, Temp, "bug_iss_scanner_rating") Then
                    ActualReport = ActualReport & _
                        "ISS Scanner rating: " & bug_iss_scanner_rating & vbCrLf
                ElseIf InStr(3, Temp, "bug_netrecon_rating") Then
                    ActualReport = ActualReport & _
                        "Symantec NetRecon rating: " & bug_netrecon_rating & vbCrLf
                ElseIf InStr(3, Temp, "bug_check_tool") Then
                    ActualReport = ActualReport & _
                        "Tools for further checks: " & bug_check_tool & vbCrLf
        ''''''''''''''''''''''''''''''''''''''''''
                ElseIf InStr(3, Temp, "source_cve") Then
                    ActualReport = ActualReport & _
                        "CVE: " & source_cve & vbCrLf
                ElseIf InStr(3, Temp, "source_securityfocus_bid") Then
                    ActualReport = ActualReport & _
                        "SecurityFocus BID: " & source_securityfocus_bid & vbCrLf
                ElseIf InStr(3, Temp, "source_secunia_id") Then
                    ActualReport = ActualReport & _
                        "Secunia ID: " & source_secunia_id & vbCrLf
                ElseIf InStr(3, Temp, "source_scipid") Then
                    ActualReport = ActualReport & _
                        "scipID: " & source_scipid & vbCrLf
                ElseIf InStr(3, Temp, "source_tecchannel_id") Then
                    ActualReport = ActualReport & _
                        "tecchannel ID: " & source_tecchannel_id & vbCrLf
                ElseIf InStr(3, Temp, "source_heise_news") Then
                    ActualReport = ActualReport & _
                        "Heise News: " & source_heise_news & vbCrLf
                ElseIf InStr(3, Temp, "source_heise_security") Then
                    ActualReport = ActualReport & _
                        "Heise Security: " & source_heise_security & vbCrLf
                ElseIf InStr(3, Temp, "source_aerasec_id") Then
                    ActualReport = ActualReport & _
                        "AeraSec ID: " & source_aerasec_id & vbCrLf
                ElseIf InStr(3, Temp, "source_nessus_id") Then
                    ActualReport = ActualReport & _
                        "Nessus ID: " & source_nessus_id & vbCrLf
                ElseIf InStr(3, Temp, "source_snort_id") Then
                   ActualReport = ActualReport & _
                        "Snort ID: " & source_snort_id & vbCrLf
                ElseIf InStr(3, Temp, "source_literature") Then
                   ActualReport = ActualReport & _
                        "Literature: " & source_literature & vbCrLf
                ElseIf InStr(3, Temp, "source_misc") Then
                   ActualReport = ActualReport & _
                        "Misc sources: " & source_misc & vbCrLf
                ElseIf InStr(3, Temp, "<br>") Then
                   ActualReport = ActualReport & vbCrLf
                End If
            End If
        Loop
    Close

    'Show the last response data if there is some
    Dim frm As Form
    For Each frm In Forms
        If frm.Name = "frmReport" Then
            frmReport.txtReport.Text = ActualReport
            Exit For
        End If
    Next frm
End Sub

'Public Sub WriteTempReportToFile()
'    Dim ReportPath As String
'
'    ReportPath = App.Path & "/reports/"
'
'    'save the actual report as text file
'    Open ReportPath & "report-" & Target & "-" & Date & ".txt" For Output As #1
'        Print #1, ActualReport
'    Close
'End Sub
